/****************************************************************************
 *            main.c
 *
 *  Mon May 29 20:26:59 2006
 *  Copyright  2006  sharandac
 *  Email sharandac(at)snafu.de
 ****************************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include <stdio.h>

#include "hardware/timer1.h"
#include "hardware/spi.h"
#include "hardware/mem-check.h"
#include "hardware/uart.h"

#include "net/network.h"

#include "apps/udp-echo.h"
#include "apps/telnet.h"
#include "apps/httpd.h"

void main(void) 
	{
	// COntroller Setup
	uart_init(12); // RS232 init mit 38400Baud
	OSCCAL = 197; // internen OSCCAL setzten um eine vernünftig genaue Uhr zu haben, wenn esterner Quarz, dann bringt dat hier nix :-)
		
	// Ein paar ausgaben zum Start
	printf_P( PSTR("%c[2J"),27 ); // Bildschirm löschen in Terminalprogram
	printf_P( PSTR("Freier Speicher in Bytes: %d\r\n"), get_mem_unused() );
	// Timer init
	timer1_init(); // timer1 init ( 1/100s ) bei 8MHz

	Network_init( DHCP | NTP | IRQMODE );

	unsigned int i;
	// Server init
	UDP_echo_init(); // UDP-EchoServer starten
	telnet_init(); // Telnet-server starten 
	httpd_init();  // http-server starten
		
	while( 1 )
	{
		UDP_echo();
		telnet_thread();
		httpd_thread();
	}
}
